322. Coin Change零钱兑换

Arithmetic Slices

题目描述

leetcode.64

You are given coins of different denominations and a total amount of money amount. Write a function to compute the fewest number of coins that you need to make up that amount. If that amount of money cannot be made up by any combination of the coins, return -1.

Example 1:

Input: coins = [1, 2, 5], amount = 11
Output: 3
Explanation: 11 = 5 + 5 + 1
Example 2:

Input: coins = [2], amount = 3
Output: -1

给定不同面额的硬币 coins 和一个总金额 amount。编写一个函数来计算可以凑成总金额所需的最少的硬币个数。如果没有任何一种硬币组合能组成总金额,返回 -1。

示例 1:

输入: coins = [1, 2, 5], amount = 11
输出: 3
解释: 11 = 5 + 5 + 1
示例 2:

输入: coins = [2], amount = 3
输出: -1

解题

这道题和0-1背包问题相似,要列一个数组,数组索引表示总金额,相当于背包问题,也要列一个数组,索引表示背包容量从0到最大。此题中,求每个金额的最优解,要遍历一次所有硬币,例如求amount=5时的最优解,要遍历所有硬币,如果当前硬币为3,最优解就是amount(2)加1,其中amount(2)是因为,此时硬币为3,所以一个情况是,总金额为2时,直接拿一个3的硬币,使得总金额到5,+1是因为多需要了1个硬币3。然后继续遍历硬币,选取最小的硬币个数。
状态转移方程:
d p [ i ] = m i n ( d p [ i ] , d p [ i − c o i n [ j ] + 1 ) dp[i]=min(dp[i],dp[i-coin[j]+1) dp[i]=min(dp[i],dp[icoin[j]+1)

class Solution {
public:
    int coinChange(vector<int>& coins, int amount) {
        vector<int> dp(amount+1,amount+1);
        dp[0] = 0;
        for(int i=1;i<=amount;i++)
        {
            for(int j=0;j<coins.size();j++)
            {
                if(coins[j]<=i)
                    dp[i] = min(dp[i],dp[i-coins[j]]+1);
            }
        }
        return dp.back()>amount?-1:dp.back();
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值